# maps words to builtin Python methods and functions
builtins = {'abs': 'abs',
            'absolute': 'abs',
            'absolutevalue': 'abs',
            'any': 'any',
            'ne': 'any',
            'ny': 'any',
            'ascii': 'ascii',
            'bin': 'bin',
            'ben': 'bin',
            'bool': 'bool',
            'boolean': 'bool',
            'bull': 'bool',
            'bytearray': 'bytearray',
            'bitearray': 'bytearray',
            'betaray': 'bytearray',
            'bytes': 'bytes',
            'bites': 'bytes',
            'callable': 'callable',
            'gullible': 'callable',
            'caldwell': 'callable',
            'chr': 'chr',
            'care': 'chr',
            'character': 'chr',
            'classmethod': 'classmethod',
            'classmessage': 'classmethod',
            'compile': 'compile',
            'complex': 'complex',
            'delattr': 'delattr',
            'delladder': 'delattr',
            'delattribute': 'delattr',
            'dayletter': 'delattr',
            'deleteadder': 'delattr',
            'deleteattribute': 'delattr',
            'dellattribute': 'delattr',
            'dict': 'dict',
            'dictionary': 'dict',
            'dick': 'dict',
            'dir': 'dir',
            'directory': 'dir',
            'derp': 'dir',
            'dare': 'dir',
            'divmod': 'divmod',
            'davemod': 'divmod',
            'divisionmod': 'divmod',
            'divisionmodulus': 'divmod',
            'divmodulus': 'divmod',
            'davemodulus': 'divmod',
            'enumerate': 'enumerate',
            'eval': 'eval',
            'avail': 'eval',
            'evaluate': 'eval',
            'exec': 'exec',
            'exact': 'exec',
            'execute': 'exec',
            'filter': 'filter',
            'float': 'float',
            'flute': 'float',
            'format': 'format',
            'frozenset': 'frozenset',
            'getattr': 'getattr',
            'getadder': 'getattr',
            'getattribute': 'getattr',
            'globals': 'globals',
            'global': 'globals',
            'hasattr': 'hasattr',
            'hasadder': 'hasattr',
            'hasattribute': 'hasattr',
            'hash': 'hash',
            'help': 'help',
            'hex': 'hex',
            'id': 'id',
            'heidi': 'id',
            'input': 'input',
            'int': 'int',
            'ant': 'int',
            'in': 'int',
            'integer': 'int',
            'isinstance': 'isinstance',
            'issubclass': 'issubclass',
            'iter': 'iter',
            'iterator': 'iter',
            'iterable': 'iterable',
            'eater': 'iter',
            'eyecare': 'iter',
            'highchair': 'iter',
            'fighter': 'iter',
            'len': 'len',
            'when': 'len',
            'length': 'len',
            'list': 'list',
            'locals': 'locals',
            'local': 'locals',
            'map': 'map',
            'max': 'max',
            'maximum': 'max',
            'memoryview': 'memoryview',
            'min': 'min',
            'men': 'min',
            'minimum': 'min',
            'next': 'next',
            'object': 'object',
            'oct': 'oct',
            'act': 'oct',
            'octal': 'oct',
            'octo': 'oct',
            'open': 'open',
            'ord': 'ord',
            'Ford': 'ord',
            'ordinal': 'ord',
            'pow': 'pow',
            'pal': 'pow',
            'power': 'pow',
            'print': 'print',
            'property': 'property',
            'range': 'range',
            'repr': 'repr',
            'reaper': 'repr',
            'rapper': 'repr',
            'representation': 'repr',
            'reversed': 'reversed',
            'reverse': 'reversed',
            'round': 'round',
            'set': 'set',
            'setattr': 'setattr',
            'setadder': 'setattr',
            'setattribute': 'setattr',
            'slice': 'slice',
            'slush': 'slice',
            'sorted': 'sorted',
            'staticmethod': 'staticmethod',
            'str': 'str',
            'stir': 'str',
            'string': 'str',
            'straigh': 'str',
            'stream': 'str',
            'strain': 'str',
            'strange': 'str',
            'sum': 'sum',
            'some': 'sum',
            'super': 'super',
            'tuple': 'tuple',
            'tuebl': 'tuple',
            'people': 'tuple',
            'teufel': 'tuple',
            'type': 'type',
            'tight': 'tight',
            'ted': 'type',
            'vars': 'vars',
            'bars': 'vars',
            'zip': 'zip',
            'import': '__import__',
            'capitalize': 'capitalize',
            'casefold': 'casefold',
            'count': 'count',
            'encode': 'encode',
            'incurred': 'encode',
            'endswith': 'endswith',
            'penswith': 'endswith',
            'expandtabs': 'expandtabs',
            'expandtab': 'expandstabs',
            'stantabs': 'expandstabs',
            'find': 'find',
            'format': 'format',
            'formatmap': 'format_map',
            'formatmac': 'format_map',
            'formatmath': 'format_map',
            'index': 'index',
            'isalnum': 'isalnum',
            'isallnum': 'isalnum',
            'isallnumb': 'isalnum',
            'iselmo': 'isalnum',
            'isalphanum': 'isalnnum',
            'isalphanumber': 'isalnum',
            'isalnumber': 'isalnum',
            'isalpha': 'isalpha',
            'isdecimal': 'isdecimal',
            'isdigit': 'isdigit',
            'isidentifier': 'isidentifier',
            'islower': 'islower',
            'islowercase': 'islower',
            'isnumeric': 'isnumeric',
            'isprintable': 'isprintable',
            'isspace': 'isspace',
            'istitle': 'istitle',
            'isupper': 'isupper',
            'isuppercase': 'isupper',
            'join': 'join',
            'joined': 'join',
            'ljust': 'ljust',
            'illjust': 'ljust',
            'leftjust': 'ljust',
            'leftchest': 'ljust',
            'letsjust': 'ljust',
            'ljustify': 'ljust',
            'eljustified': 'ljust',
            'leftjustify': 'ljust',
            'lower': 'lower',
            'lowercase': 'lower',
            'lstrip': 'lstrip',
            'elstrip': 'lstrip',
            'leftstrip': 'lstrip',
            'letstrip': 'lstrip',
            'maketrans': 'maketrans',
            'meitranslation': 'maketrans',
            'maketranslation': 'maketrans',
            'partition': 'partition',
            'replace': 'replace',
            'rfind': 'rfind',
            'arfind': 'rfind',
            'arefind': 'rfind',
            'rightfind': 'rfind',
            'grapevine': 'rfind',
            'rindex': 'rindex',
            'areindex': 'rindex',
            'rightindex': 'rindex',
            'ratedx': 'ratedx',
            'birdindex': 'rindex',
            'rateindex': 'rindex',
            'rjust': 'rjust',
            'arejust': 'rjust',
            'rightjust': 'rjust',
            'rightchest': 'rjust',
            'rightjustify': 'rjust',
            'arejustify': 'rjust',
            'arejustified': 'rjust',
            'rpartition': 'rpartition',
            'arepartition': 'rpartition',
            'rightpartition': 'rpartition',
            'rsplit': 'rsplit',
            'rightsplit': 'rsplit',
            'aresplit': 'rsplit',
            'rstrip': 'rstrip',
            'arestrip': 'rstrip',
            'rightstrip': 'rstrip',
            'greatstrip': 'rstrip',
            'split': 'split',
            'splitlines': 'splitlines',
            'splitline': 'splitlines',
            'sportlines': 'splitlines',
            'startswith': 'startswith',
            'strip': 'strip',
            'stripped': 'strip',
            'swapcase': 'swapcase',
            'softcase': 'swapcase',
            'title': 'title',
            'translate': 'translate',
            'upper': 'upper',
            'offer': 'upper',
            'uppercase': 'upper',
            'zfill': 'zfill',
            'refill': 'zfill',
            'append': 'append',
            'extend': 'extend',
            'insert': 'insert',
            'pop': 'pop',
            'remove': 'remove',
            'reverse': 'reverse',
            'sort': 'sort',
            'short': 'sort',
            'clear': 'clear',
            'copy': 'copy',
            'coffee': 'copy',
            'fromkeys': 'fromkeys',
            'frankies': 'fromkeys',
            'get': 'get',
            'haskey': 'has_key',
            'husky': 'has_key',
            'heskey': 'has_key',
            'items': 'items',
            'tatums': 'items',
            'diddams': 'items',
            'keys': 'keys',
            'setdefault': 'setdefault',
            'setthefall': 'setdefault',
            'setthephone': 'setdefault',
            'update': 'update',
            'issubset': 'issubset',
            'issuperset': 'issuperset',
            'union': 'union',
            'intersection': 'intersection',
            'difference': 'difference',
            'symmetricdifference': 'symmetric_difference',
            'add': 'add',
            'ed': 'add',
            'ad': 'add',
            'discard': 'discard'}


# converts text to a builtin function name
def to_builtin(val):
    builtin = "".join(i for i in val.lower() if i.isalpha())
    if builtin in builtins:
        return builtins[builtin]
    else:
        return False
